tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator > Class Template Reference
Inheritance diagram for tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >:
Collaboration diagram for tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >:

## Public Member Functions

| iterator_impl ()
Iterator & | operator= (const Iterator &it)
Iterator & | operator= (const T &val)
bool | operator== (const Iterator &it) const
bool | operator!= (const Iterator &it) const
Iterator & | operator++ ()
Iterator & | operator-- ()
Iterator | operator++ (int)
Iterator | operator-- (int)

## Protected Member Functions

| iterator_impl (intrusive_list_node *pos)
T & | item () const

## Private Member Functions

Iterator & | self ()

## Private Attributes

intrusive_list_node * | my_pos
| Node the iterator points to at the moment. More...

## Detailed Description

### template<class List, class T>
template<class Iterator>
class tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >

Definition at line 53 of file intrusive_list.h.

## Constructor & Destructor Documentation

## iterator_impl() [1/2]

template<class List, class T>
template<class Iterator>

tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::iterator_impl | ( | intrusive_list_node * | pos | ) |

inline protected

Definition at line 60 of file intrusive_list.h.

: my_pos(pos)
{}

## iterator_impl() [2/2]

template<class List, class T>
template<class Iterator>

tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::iterator_impl | ( |  | ) |

inline

Definition at line 69 of file intrusive_list.h.

: my_pos(NULL) {}

## Member Function Documentation

## item()

template<class List, class T>
template<class Iterator>

T& tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::item | ( |  | ) | const

inline protected

Definition at line 64 of file intrusive_list.h.

{
return intrusive_list_base::item(my_pos);
}

## operator!=()

template<class List, class T>
template<class Iterator>

bool tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator!= | ( | const Iterator & | it | ) | const

inline

Definition at line 83 of file intrusive_list.h.

{
return my_pos != it.my_pos;
}

## operator++() [1/2]

template<class List, class T>
template<class Iterator>

Iterator& tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator++ | ( |  | ) |

inline

Definition at line 87 of file intrusive_list.h.

{
my_pos = my_pos->my_next_node;
return self();
}

## operator++() [2/2]

template<class List, class T>
template<class Iterator>

Iterator tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator++ | ( | int |  | ) |

inline

Definition at line 97 of file intrusive_list.h.

{
Iterator result = self();
++(*this);
return result;
}

## operator--() [1/2]

template<class List, class T>
template<class Iterator>

Iterator& tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator-- | ( |  | ) |

inline

Definition at line 92 of file intrusive_list.h.

{
my_pos = my_pos->my_prev_node;
return self();
}

## operator--() [2/2]

template<class List, class T>
template<class Iterator>

Iterator tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator-- | ( | int |  | ) |

inline

Definition at line 103 of file intrusive_list.h.

{
Iterator result = self();
--(*this);
return result;
}

## operator=() [1/2]

template<class List, class T>
template<class Iterator>

Iterator& tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator= | ( | const Iterator & | it | ) |

inline

Definition at line 71 of file intrusive_list.h.

{
return my_pos = it.my_pos;
}

## operator=() [2/2]

template<class List, class T>
template<class Iterator>

Iterator& tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator= | ( | const T & | val | ) |

inline

Definition at line 75 of file intrusive_list.h.

{
return my_pos = &node(val);
}

## operator==()

template<class List, class T>
template<class Iterator>

bool tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::operator== | ( | const Iterator & | it | ) | const

inline

Definition at line 79 of file intrusive_list.h.

{
return my_pos == it.my_pos;
}

## self()

template<class List, class T>
template<class Iterator>

Iterator& tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::self | ( |  | ) |

inline private

Definition at line 54 of file intrusive_list.h.

{ return *static_cast<Iterator*>(this); }

## Member Data Documentation

## my_pos

template<class List, class T>
template<class Iterator>

intrusive_list_node* tbb::internal::intrusive_list_base< List, T >::iterator_impl< Iterator >::my_pos

private

Node the iterator points to at the moment.

Definition at line 57 of file intrusive_list.h.

Referenced by tbb::internal::intrusive_list_base< List, T >::iterator_impl< const_iterator >::item(), tbb::internal::intrusive_list_base< List, T >::iterator_impl< const_iterator >::operator!=(), tbb::internal::intrusive_list_base< List, T >::iterator_impl< const_iterator >::operator++(), tbb::internal::intrusive_list_base< List, T >::iterator_impl< const_iterator >::operator--(), tbb::internal::intrusive_list_base< List, T >::iterator_impl< const_iterator >::operator=(), and tbb::internal::intrusive_list_base< List, T >::iterator_impl< const_iterator >::operator==().

The documentation for this class was generated from the following file:

- intrusive_list.h

tbb::internal::intrusive_list_base::item
static T & item(intrusive_list_node *node)
Definition: intrusive_list.h:50
tbb::internal::intrusive_list_base::iterator_impl::my_pos
intrusive_list_node * my_pos
Node the iterator points to at the moment.
Definition: intrusive_list.h:57
tbb::internal::intrusive_list_base::node
static intrusive_list_node & node(T &item)
Definition: intrusive_list.h:48
tbb::internal::intrusive_list_node::my_next_node
intrusive_list_node * my_next_node
Definition: intrusive_list.h:31
tbb::internal::intrusive_list_node::my_prev_node
intrusive_list_node * my_prev_node
Definition: intrusive_list.h:31

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.